	ORG	100h
	CPU 8086
section .text
;;;;	jmp	old9801	;test用

	xor	ax,ax
	mov	es,ax
	mov	al,[es:501h]
	and	al,08h
	cmp	al,08h
	je	END		;ハイレゾ禁止

	mov	ax,300Ch
	mov	bh,21h
	int	18h		;BIOSで31khzの640x400にしてみる
	cmp	ah,05h
	je	END		;通ったならGRPH-2対応機種ですよ 余計なことしない

	mov	ax,300ch
	mov	bh,32h
	int	18h		;まずはBIOSで640x480の256色に変えてみる
	cmp	ah,05h
	jne	old9801	;ダメだったら下に飛ぶ
;こっちにきた時点でG-GDCは5Mhzに設定しなおされる 原因は640x480の256色に2.5Mhzはないことになっているから

	mov	dx,6ah
	mov	al,07h
	call	outee
	mov	al,20h		;16色に戻して
	call	outee
	mov	al,06h
	call	outee


	mov	ax,3008h
	mov	bh,21h
	int	18h		;BIOSで24khzの640x400に戻しておく ワークエリアの値を整理

	mov	dx,09a8h
	mov	al,01h		;ピクセルクロック25.175Mhz
	call	outee

;T-GDCをパラメータで31khzにする
	mov	dx,62h
	mov	al,0eh		;GDC SYNCコマンド
	call	outee

	mov	dx,60h
	mov	al,10h
	call	outee
	mov	al,4eh;==78+2=80 横のキャラ数 1キャラ8dotで横幅640dot
	call	outee
	mov	al,47h;HSYNC=7+1=8char VSYNC=4line
	call	outee
	mov	al,0ch;HFP=3+1=4char
	call	outee
	mov	al,07h;HBP=7+1=8char
	call	outee
	mov	al,0dh;VFP=13line
	call	outee
	mov	al,90h
	call	outee
	mov	al,89h;190h=400line VBP=17lines
	call	outee



	mov	dx,62h
	mov	al,05h	;stop
	call	outee

	mov	dx,62h
	mov	al,47h	;pitch
	call	outee
	mov	dx,60h
	mov	al,50h
	call	outee

	mov	dx,62h
	mov	al,70h	;scroll
	call	outee
	mov	dx,60h
	mov	al,0h
	call	outee
	mov	al,0h
	call	outee
	mov	al,0f0h
	call	outee
	mov	al,03fh
	call	outee
	
;G-GDCの方も640x400の31khzに合わせる
	mov	dx,0a2h
	mov	al,0eh		;GDC SYNCコマンド
	call	outee

	mov	dx,0a0h
	mov	al,2h
	call	outee
	mov	al,4eh;==78+2=80 横のキャラ数 1キャラ8dotで横幅640dot
	call	outee
	mov	al,43h;
	call	outee
	mov	al,1Ch;
	call	outee
	mov	al,87h;
	call	outee
	mov	al,0dh;
	call	outee
	mov	al,90h
	call	outee
	mov	al,89h;
	call	outee

	mov	dx,0a2h
	mov	al,05h	;stop
	call	outee

	mov	dx,0a2h
	mov	al,47h	;pitch
	call	outee
	mov	dx,0a0h
	mov	al,50h
	call	outee


	mov	dx,0a2h
	mov	al,70h	;scroll
	call	outee
	mov	dx,0a0h
	mov	al,0h
	call	outee
	mov	al,0h
	call	outee
	mov	al,0f0h
	call	outee
	mov	al,03fh
	call	outee

	mov	dx,0a2h
	mov	al,4bh	;CSRFORM
	call	outee
	mov	dx,0a0h
	mov	al,0h
	call	outee

END:				;場所変更
	mov	dx,62h
	mov	al,0dh		;GDC再動
	call	outee

	ret

old9801:
	mov	dx,62h
	mov	al,0eh		;GDC SYNCコマンド
	call	outee

	mov	dx,60h
	mov	al,10h
	call	outee
	mov	al,4eh;==78+2=80 横のキャラ数 1キャラ8dotで横幅640dot
	call	outee
	mov	al,0h;HSYNC==0+1=1char 
	call	outee
	mov	al,5h;VSYNC==8lines H_FrontPorch==1+1=2char
	call	outee
	mov	al,0h;==H_BackPorch==0+1=1char
	call	outee
	mov	al,07h;==V_FrontPorch=7lines
	call	outee
	mov	al,90h
	call	outee
	mov	al,65h;==上と合わせて縦dot=190h==400 V_BackPorch=19h==25line
	call	outee



	mov	dx,62h
	mov	al,05h	;stop
	call	outee

	mov	dx,62h
	mov	al,47h	;pitch
	call	outee
	mov	dx,60h
	mov	al,50h
	call	outee


	mov	dx,62h
	mov	al,70h	;scroll
	call	outee
	mov	dx,60h
	mov	al,0h
	call	outee
	mov	al,0h
	call	outee
	mov	al,0f0h
	call	outee
	mov	al,03fh
	call	outee


	mov	dx,62h
	mov	al,0dh
	call	outee

	mov	dx,09a8h
	mov	al,00h		;21.053Mhz 一応
	call	outee

;G-GDCも面倒見てみます 絶対ダメ! グラフィックBIOSが呼べなくなる
;違う!! 起動時GDCが5Mhzだと暴走することが判明! どうすっかなあ
%if 1
	mov	dx,0a2h
	mov	al,0eh		;GDC SYNCコマンド
	call	outee

	mov	dx,0a0h
	mov	al,2h
	call	outee
	mov	al,4eh;==78+2=80 横のキャラ数 1キャラ8dotで横幅640dot
	call	outee
	mov	al,0h;HSYNC==0+1=1char 
	call	outee
	mov	al,5h;VSYNC==8lines H_FrontPorch==1+1=2char
	call	outee
	mov	al,0h;==H_BackPorch==0+1=1char
	call	outee
	mov	al,07h;==V_FrontPorch=7lines
	call	outee
	mov	al,90h
	call	outee
	mov	al,65h;==上と合わせて縦dot=190h==400 V_BackPorch=19h==25line
	call	outee


	mov	dx,0a2h
	mov	al,05h	;stop
	call	outee

	mov	dx,0a2h
	mov	al,47h	;pitch
	call	outee
	mov	dx,0a0h
	mov	al,50h
	call	outee


	mov	dx,0a2h
	mov	al,70h	;scroll
	call	outee
	mov	dx,0a0h
	mov	al,0h
	call	outee
	mov	al,0h
	call	outee
	mov	al,0f0h
	call	outee
	mov	al,03fh
	call	outee

	mov	dx,0a2h
	mov	al,4bh	;CSRFORM
	call	outee
	mov	dx,0a0h
	mov	al,0h
	call	outee
%endif
	mov	dx,6ah
	mov	al,01h
	call	outee		;ただし16色モードにしてE000は開けておく

	push	ds
	xor	bx,bx
	mov	ds,bx
	mov	bx,54dh
	mov	al,[bx]
;;	and	al,20h
;;	pop	ds
;;	cmp	al,20h
;;	je	GDC5Mhz		;起動時5Mhzなら下を触らずにやる
;;				;ただし起動時5Mhzなら画面が上下二分割になるプログラム多数

	and	al,04h
	pop	ds
	cmp	al,04h			;PC-9801DXは起動時5Mhz設定でも立ってない!!
	je	GDC5Mhz		;現在5Mhzなら下を触らずに進ませる


	mov	al,83h
	call	outee		;G-GDCも5Mhzにしないと追いつかないでしょ?

	mov	al,85h
	call	outee		;G-GDCも5Mhzにしないと追いつかないでしょ?

	push	ds
	xor	bx,bx
	mov	ds,bx
	mov	bx,54dh
	or	byte	[bx],4h	;5Mhz設定
	pop	ds

GDC5Mhz:
	mov	ah,40h
	int	18h		;これが通らないならどうせOSもすぐこける

	mov	ch,0c0h	;640x400設定
	mov	ah,42h
	int	18h		;これも通らないならどうせOSもすぐこける

	jmp	END
outee:
	out	5fh,al
	out	dx,al
	ret


%if 0
;640x480の場合の設定値
	mov	dx,60h
	mov	al,10h
	call	outee
	mov	al,4eh;==78+2=80 横のキャラ数 1キャラ8dotで横幅640dot
	call	outee
	mov	al,4bh;HSYNC=B+1=12char VSYNC=1line
	call	outee
	mov	al,ch; HFP=3+1=4char
	call	outee
	mov	al,03h;HBP=3+1=4char
	call	outee
	mov	al,06h;VFP=6line
	call	outee
	mov	al,0e0h
	call	outee
	mov	al,95h;480lines VBP=37line
	call	outee
%endif